/*● Consulta todos los clientes que han alquilado películas*/
SELECT CU.FIRST_NAME 
FROM CUSTOMER AS CU
JOIN RENTAL AS REN ON CU.CUSTOMER_ID=REN.CUSTOMER_ID

/*● Obtenga todos los clientes que hayan vencido la fecha de vencimiento de pago.
Muestra también por qué películas vencen sus pagos.*/

SELECT DISTINCT CU.FIRST_NAME 
FROM CUSTOMER CU
JOIN RENTAL REN ON REN.CUSTOMER_ID=CU.CUSTOMER_ID
JOIN PAYMENT PAY ON PAY.CUSTOMER_ID=CU.CUSTOMER_ID
WHERE RETURN_DATE<=PAYMENT_DATE;

/*● ¿Cuáles son las categorías más alquiladas?*/
SELECT DISTINCT TITLE
FROM FILM 
WHERE RENTAL_RATE=(SELECT MAX(RENTAL_RATE) FROM FILM);

/*Cuales son las categorías más alquiladas agrupadas por cliente*/
SELECT DISTINCT NAME
FROM CATEGORY CAT
JOIN FILM_CATEGORY FIC ON CAT.CATEGORY_ID=FIC.CATEGORY_ID
JOIN FILM FI ON FI.FILM_ID=FIC.FILM_ID
WHERE RENTAL_RATE=(SELECT MAX(RENTAL_RATE)FROM FILM);

/*Cual es el lenguaje más alquilado*/

SELECT DISTINCT LEN.NAME
FROM LANGUAGE LEN
JOIN FILM FI ON FI.LANGUAGE_ID=LEN.LANGUAGE_ID
WHERE RATING = (SELECT MAX(RATING) FROM FILM);
/*● Cuál empleados son los mejores. Significa cual empleados se alquila maximo películas*/
SELECT DISTINCT FIRST_NAME
FROM STAFF STA
JOIN RENTAL REN ON REN.STAFF_ID=STA.STAFF_ID
JOIN INVENTORY INV ON INV.INVENTORY_ID=REN.INVENTORY_ID
JOIN FILM FI ON FI.FILM_ID=INV.FILM_ID
WHERE  TITLE=(SELECT MAX(TITLE)FROM FILM);

/*Quién es el actor más famoso. Significa películas de cual actor se alquila maximo*/
SELECT DISTINCT FIRST_NAME
FROM ACTOR AC
JOIN FILM_ACTOR FAC ON FAC.ACTOR_ID=AC.ACTOR_ID
JOIN FILM FI ON FI.FILM_ID=FAC.FILM_ID
JOIN INVENTORY INV ON FI.FILM_ID=INV.FILM_ID
JOIN RENTAL REN ON REN.INVENTORY_ID=INV.INVENTORY_ID
WHERE  TITLE=(SELECT MAX(TITLE)FROM FILM);
/*Quien es el mejor cliente. ¿Significa quien alquila máximo?*/
SELECT DISTINCT FIRST_NAME
FROM CUSTOMER CUS
JOIN PAYMENT PAY ON PAY.CUSTOMER_ID=CUS.CUSTOMER_ID
WHERE AMOUNT = (SELECT MAX(AMOUNT) FROM PAYMENT);